#include <string.h>
#include <stdlib.h>
#include "../xmetoo-src/xmc.h"
#include "cam2jav.h"

extern void clear_metoobuf();

JNIEXPORT void JNICALL Java_cam2jav_camInit
  (JNIEnv *env, jobject obj) {

  char cmd[255]; char *x[1];

  sprintf(cmd,"%s/.metoorc",getenv("HOME"));
  x[0] = strdup(cmd);

  libxminit(1,x);
}

JNIEXPORT jstring JNICALL Java_cam2jav_camEval
  (JNIEnv *env, jobject obj, jstring jstr) {

  SEXP r;
  char i[1000];
  char o[10000];
  char t[10000];

  const char *str = (*env)->GetStringUTFChars(env,jstr,0);

  clear_metoobuf();

#ifdef DEBUG
  char *x;
  x = strdup(str);
  printf("input:%s\n",x);
#endif

  strcpy(i,str);
  if (seca(i,o) == 0) {
      if ((r = libxmevalstr(o)) != XM_ERROR)
          sexp2cam(t,r);
      else {
          strcpy(t,"x:syntax error!");
      }
  } else {
      strcpy(t,"c:syntax error!");
  }

#ifdef DEBUG
  printf("here i go...\n");
  puts(t);
#endif

  (*env)->ReleaseStringUTFChars(env,jstr,str);

#ifdef LINUX
  return makeJavaString(t,strlen(t));
#else
  return (*env)->NewStringUTF(env,t);
#endif
}

JNIEXPORT void JNICALL Java_cam2jav_camCompile
  (JNIEnv *env, jobject obj, jstring jstr) {

  char c[255];

  const char *str = (*env)->GetStringUTFChars(env,jstr,0);

  //strcpy(c,"$CAMILA/bin/seca ");
  strcpy(c,"seca ");
  strcat(c,str);
  strcat(c,"> _tmp_");
  system(c);
}

JNIEXPORT void JNICALL Java_cam2jav_camExecute
  (JNIEnv *env, jobject obj, jstring jstr) {

  char c[255];

  const char *str = (*env)->GetStringUTFChars(env,jstr,0);

  strcpy(c,"seca ");
  strcat(c,str);
  strcat(c,"> _tmp_");
  system(c);
  strcpy(c,"(load \"_tmp_\")");
  libxmevalstr(c);
}

JNIEXPORT void JNICALL Java_cam2jav_camExShell
  (JNIEnv *env, jobject obj, jstring jstr) {

  char cmd[255];

  const char *str = (*env)->GetStringUTFChars(env,jstr,0);

  //strcpy(cmd,"xterm -e $CAMILA/bin/camila ");
  strcpy(cmd,"xterm -e camila ");
  strcat(cmd,str);
  strcat(cmd," &");
  system(cmd);

  (*env)->ReleaseStringUTFChars(env,jstr,str);
}

JNIEXPORT void JNICALL Java_cam2jav_camShell
  (JNIEnv *env, jobject obj) {

  char cmd[255];

  //strcpy(cmd,"xterm -e $CAMILA/bin/camila ");
  strcpy(cmd,"xterm -e camila &");
  system(cmd);
}


JNIEXPORT void JNICALL Java_cam2jav_camMan
  (JNIEnv *env, jobject obj, jstring jstr) {

  char cmd[255];

  const char *str = (*env)->GetStringUTFChars(env,jstr,0);

  //strcpy(cmd,"perl $CAMILA/bin/cam2man ");
  strcpy(cmd,"cam2man "); strcat(cmd,str);
  system(cmd);
  strcpy(cmd,"nroff -man "); strcat(cmd,str); strcat(cmd,".man > _man");
  system(cmd);
  strcpy(cmd,"xterm -e more _man &");
  system(cmd);

  (*env)->ReleaseStringUTFChars(env,jstr,str);
}

JNIEXPORT void JNICALL Java_cam2jav_camShowMan
  (JNIEnv *env, jobject obj, jstring jstr) {

  char cmd[255];

  const char *str = (*env)->GetStringUTFChars(env,jstr,0);

  strcpy(cmd,"netscape -remote 'openUrl(");
/*
  strcat(cmd,getenv("CAMILA"));
  strcat(cmd,"/lib/doc/");
*/
  strcat(cmd,str); strcat(cmd,")'");
  system(cmd);
/*
  strcpy(cmd,"xterm -e nroff -man ");
  strcat(cmd,str);
  strcat(cmd," | more");
  system(cmd);
*/

  (*env)->ReleaseStringUTFChars(env,jstr,str);
}

JNIEXPORT void JNICALL Java_cam2jav_camHtml
  (JNIEnv *env, jobject obj, jstring jstr) {

  char cmd[255];

  const char *str = (*env)->GetStringUTFChars(env,jstr,0);

  //strcpy(cmd,"perl $CAMILA/bin/cam2man ");
  strcpy(cmd,"cam2man "); strcat(cmd,str);
//puts(cmd);
  system(cmd);
  //sprintf(cmd,"pod2html --outfile=%s.html %s.pod",str,str);
  sprintf(cmd,"pod2html %s.pod > %s.html",str,str);
//puts(cmd);
  system(cmd);
  sprintf(cmd,"netscape -remote 'openUrl(%s.html)' &",str);
	//puts(cmd);
  system(cmd);

  (*env)->ReleaseStringUTFChars(env,jstr,str);
}

JNIEXPORT void JNICALL Java_cam2jav_camPretty
  (JNIEnv *env, jobject obj, jstring jstr) {

  char cmd[255];

  const char *str = (*env)->GetStringUTFChars(env,jstr,0);

  sprintf(cmd,"jjpretty %s",str);
  system(cmd);
  strcpy(cmd,"latex _pretty");
  system(cmd);
  strcpy(cmd,"xdvi _pretty &");
  system(cmd);

  (*env)->ReleaseStringUTFChars(env,jstr,str);
}

JNIEXPORT void JNICALL Java_cam2jav_camERReif
  (JNIEnv *env, jobject obj, jstring jstr1) {

  char cmd[255];

  const char *str1 = (*env)->GetStringUTFChars(env,jstr1,0);

  strcpy(cmd,"echo \"fName <- \\\"");
  strcat(cmd,str1);
  strcat(cmd,"\\\";\" > _.cam");
printf("out %s",cmd);
  system(cmd);
  //strcpy(cmd,"cat run-er.cam >> _.cam");
  sprintf(cmd,"cat %s/lib/cam/run-er.cam >> _.cam",getenv("CAMILA"));
  system(cmd);
  strcpy(cmd,"xterm -e camila _.cam &");
  system(cmd);
/*
  libxmevalstr("(load \"arf.met\")");
  strcpy(cmd,"(XMT2SETS \"");
  strcat(cmd,str1);
  strcat(cmd,"\")");
  libxmevalstr(cmd);
  strcpy(cmd,"(rfPREPARE \"");
  strcat(cmd,str2);
  strcat(cmd,"\")");
  libxmevalstr(cmd);
  libxmevalstr("(expand 20)");
  libxmevalstr("(rfPSTARTPPD x 1 2)");
*/
  (*env)->ReleaseStringUTFChars(env,jstr1,str1);
}

JNIEXPORT void JNICALL Java_cam2jav_camFFReif
  (JNIEnv *env, jobject obj, jstring jstr1) {

  char cmd[255];

  const char *str1 = (*env)->GetStringUTFChars(env,jstr1,0);

  strcpy(cmd,"echo \"fName <- \\\"");
  strcat(cmd,str1);
  strcat(cmd,"\\\";\" > _.cam");
printf("out %s",cmd);
  system(cmd);
  //strcpy(cmd,"cat run-ff.cam >> _.cam");
  sprintf(cmd,"cat %s/lib/cam/run-ff.cam >> _.cam",getenv("CAMILA"));
  system(cmd);
  strcpy(cmd,"xterm -e camila _.cam &");
  system(cmd);
/*
  libxmevalstr("(load \"arf.met\")");
  strcpy(cmd,"(XMT2SETS \"");
  strcat(cmd,str1);
  strcat(cmd,"\")");
  libxmevalstr(cmd);
  strcpy(cmd,"(rfPREPARE \"");
  strcat(cmd,str2);
  strcat(cmd,"\")");
  libxmevalstr(cmd);
  libxmevalstr("(expand 20)");
  libxmevalstr("(rfPSTARTPPD x 1 2)");
*/
  (*env)->ReleaseStringUTFChars(env,jstr1,str1);
}

JNIEXPORT void JNICALL Java_cam2jav_camPrettyReif
  (JNIEnv *env, jobject obj, jstring jstr) {

  char cmd[255];

  const char *str = (*env)->GetStringUTFChars(env,jstr,0);

/*
  strcpy(cmd,"(rfSAVEREIF x)");
  libxmevalstr(cmd);
  strcpy(cmd,"latex ");
  strcat(cmd,str); strcat(cmd," &");
  system(cmd);
*/
  strcpy(cmd,"xdvi ");
  strcat(cmd,str); //strcat(cmd," &");
  system(cmd);

  (*env)->ReleaseStringUTFChars(env,jstr,str);
}

JNIEXPORT void JNICALL Java_cam2jav_camReifRules
  (JNIEnv *env, jobject obj) {

  char cmd[255];

  //strcpy(cmd,"latex _reif_ &");
  //system(cmd);
  strcpy(cmd,"xdvi _rules_");
  system(cmd);
}


JNIEXPORT void JNICALL Java_cam2jav_camMoreAbout
  (JNIEnv *env, jobject obj, jstring jstr) {

  char cmd[255];

  const char *str = (*env)->GetStringUTFChars(env,jstr,0);

  strcpy(cmd,"netscape -remote 'openUrl (");
  strcat(cmd,getenv("CAMILA"));
  strcat(cmd,"/doc/");
  strcat(cmd,str);
  strcat(cmd,")' &");
  system(cmd);

  (*env)->ReleaseStringUTFChars(env,jstr,str);
}

JNIEXPORT void JNICALL Java_cam2jav_camApplet
  (JNIEnv *env, jobject obj, jstring jstr) {

  char cmd[255];

  const char *str = (*env)->GetStringUTFChars(env,jstr,0);

  strcpy(cmd,"appletviewer ");
  strcat(cmd,str);
  //strcat(cmd," &");
  system(cmd);

  (*env)->ReleaseStringUTFChars(env,jstr,str);
}

JNIEXPORT jstring JNICALL Java_cam2jav_getRscDir
  (JNIEnv *env, jobject obj) {

  char t[10000];

  sprintf(t,"%s/lib/rsc/",getenv("CAMILA"));
#ifdef LINUX
  return makeJavaString(t,strlen(t));
#else
  return (*env)->NewStringUTF(env,t);
#endif
}

JNIEXPORT jstring JNICALL Java_cam2jav_getCamDir
  (JNIEnv *env, jobject obj) {

  char t[10000];

  sprintf(t,"%s/lib/cam/",getenv("CAMILA"));
#ifdef LINUX
  return makeJavaString(t,strlen(t));
#else
  return (*env)->NewStringUTF(env,t);
#endif
}

JNIEXPORT jstring JNICALL Java_cam2jav_getSigDir
  (JNIEnv *env, jobject obj) {

  char t[10000];

  sprintf(t,"%s/lib/sig/",getenv("CAMILA"));
#ifdef LINUX
  return makeJavaString(t,strlen(t));
#else
  return (*env)->NewStringUTF(env,t);
#endif
}

JNIEXPORT jstring JNICALL Java_cam2jav_getDocDir
  (JNIEnv *env, jobject obj) {

  char t[10000];

  sprintf(t,"%s/lib/doc/",getenv("CAMILA"));
#ifdef LINUX
  return makeJavaString(t,strlen(t));
#else
  return (*env)->NewStringUTF(env,t);
#endif
}

