/*	Muitas vezes se poderia usar as funcoes 'arg_n_opt' do xmc.h, mas... 
   ao tentar usar as funcoes que a usassem davam sempre um erro no lado
   camilerio: "error: invalid argument"	

Uma sugestao: uma 'form' nao e mais do que uma funcao finita de nome da 'form'
	para um tuplo que conteria as informacoes necessarias 'a sua construcao. 
	Entao nao seria interessante isso ser feito...

Notas:
1) esta versao nao contempla a possibilidade de cascade;

2) ha um bug na remocao das janelas via 'ric_destroy', pois elas sao destruidas
   mas a variavel camila que guardou o seu nome continua a existir, o que nao
   deve; a solucao e' bastante simples uma vez que e' a propria var. que e' 
   recebida por ric_destroy!
2.1) pois parece simples, mas nao e' pois as nome_aluno, etc, nao serao tao
     facilmente "digeridas"!!!

3) em varios sitios e' melhor usar os gets do que o forall;

4) em le seria bom nao usar um ciclo de espera activa, mas como fazer entao...

5) o focus devera' ser armadilhado por forma a que nao se troque a ordem das coisas   
   nas entries senao fica tudo estragado...

*/

#ifdef TCLTK

#include "cla.h"
#include "ricardo.h"

/* ----------------- Zona de sinais --------------------*/ 

void segv_handler() 
{
    signal(SIGSEGV,segv_handler);
	fprintf(stderr,"SIGSEGV \n");
	exit(1);
}

void bus_handler()
{
	signal(SIGBUS,bus_handler);
	fprintf(stderr,"SIGBUS \n");
	exit(1);
}

void int_handler()
{
	signal(SIGINT,int_handler);
	fprintf(stdout,"Exiting under ^C\n\a");
	exit(1);
}
	
void ric_alrm()
{
        signal(SIGALRM,ric_alrm);
/*
        if( Tcl_Eval(interp,"update") != TCL_OK )
                fprintf(stderr,"Tcl_Eval Failed: %s\n",interp->result);
*/
		
        if( Tcl_Eval(interp,"update") != TCL_OK )
                fprintf(stderr,"Tcl_Eval Failed: %s\n",interp->result);
		else 
			Tcl_ResetResult(interp);
/*		Tk_DoOneEvent(TK_ALL_EVENTS);*/
		
        alarm(1);
}

/*
void no_focus(ClientData clientdata,XEvent *eventptr)
{
	fprintf(stdout,"\n\nCapturei um focus in...\n\a\a\a\a");
}
*/

/* --------------- Fim de zona de sinais -------------- */

void xmtcltkinit()
{
	pid_t pid;
  	Tk_Window mainWindow;
  	static char *display = NULL;

	printf("Inicializacao - Fase 1 -- Tcl/Tk\n");

  	/* Tcl/Tk initialization */
  	interp = Tcl_CreateInterp();
	printf("Inicializacao - Fase 2\n");

  	mainWindow = Tk_CreateMainWindow(interp, display, "R - Camila", "Tk");
	printf("Inicializacao - Fase 3\n");
  	if (mainWindow == NULL) {
  		fprintf(stderr, "%s\n", interp->result);
    	exit(1);
  	}
	printf("Inicializacao - Fase 4\n");

  	if (Tcl_Init(interp) == TCL_ERROR) {
    	fprintf(stderr, "Tcl_Init failed: %s\n", interp->result);
  	}
	printf("Inicializacao - Fase 5\n");
  	if (Tk_Init(interp) == TCL_ERROR) {
    	fprintf(stderr, "Tk_Init failed: %s\n", interp->result);
  	}
	printf("Inicializacao - Fase 6\n");
  	Tk_MapWindow(mainWindow);

  	Tcl_SetVar(interp, "tcl_interactive", "0", TCL_GLOBAL_ONLY);

	printf("Inicializacao - Fase 7 -- instalacao de sig_handlers\n");
    /* instalar handler experimental */
    signal(SIGALRM,ric_alrm);

    signal(SIGSEGV,segv_handler);
    signal(SIGBUS,bus_handler);
    signal(SIGINT,int_handler);

	printf("Inicializacao - Fase 8 -- criacao de novos comandos tk\n");

	Tcl_CreateCommand(interp,"tkcom_exe_but",I_exe_but,NULL,NULL); 	/* funcao para executar um bind associado a um botao   */
	Tcl_CreateCommand(interp,"tkcom_opcao",I_opcao,NULL,NULL); 	/* funcao para executar um bind associado a uma opcao dum menu */

	/*Tk_CreateEventHandler(mainWindow,FocusInMask,no_focus,NULL);*/
	/*Tk_CreateGenericHandler(desperta,NULL);*/

	printf("Inicializacao - Fase 9 -- inicializacao de variaveis\n");
	ric_inic();
}

/* -------------------------------- MY WAVE --------------------------------- */

/* ------------------ Tk internals -------------------- */

int I_opcao(ClientData clientdata, Tcl_Interp *interp, int argc, char *argv[])
{
	rv *aux,*lixo;
	
	ric_getptr(argv[1],&aux,&lixo);	/* argv[1] tem o nome da janela (opcao) que devera ser usada */

	if(aux)		/* se sempre se encontrou a opcao */
		xleval(aux->in.opcao.to_execute);		/* faz-se o eval da sexp associada */
	return TCL_OK;
}

int I_exe_but(ClientData clientdata, Tcl_Interp *interp, int argc, char *argv[])
{
	rv *aux,*lixo;
	SEXP res = NULL;

	ric_getptr(argv[1],&aux,&lixo);
	
	if(aux)		/* se sempre se encontrou o botao */
		res = xleval(aux->in.but.evento);		/* faz-se o eval da sexp associada */

/*
	if(res) 
		printf("res = %d\n",res->n_int);
	else
		printf("res = NULL\n");
*/
	return TCL_OK;
}

/*
int I_exe_but(ClientData clientdata, Tcl_Interp *interp, int argc, char *argv[])
{
	int i;
	SEXP res=NULL;
	Tcl_DString comando;

	Tcl_DStringInit(&comando);

	for(i=1;i<argc;i++)
		Tcl_DStringAppendElement(&comando,argv[i]);
		res = conssexp(strsexp(argv[i]),res);

	comando.string = remove_chavetas(comando.string);
	libxmevalstr(comando.string);
	printf("comando = '%s'\n",comando.string);
	Tcl_DStringFree(&comando);
	xleval(res);
	return TCL_OK;
}
*/


/* ---------------- Fim Tk internals ------------------ */



/* ------------- Funcoes auxiliares das funcoes de Camila ----------------- */

void ric_inic()
{
	contador = 0;

	cabeca = (rv *)malloc(sizeof(rv));
	cabeca -> tipo_janela = TK;
	strcpy(cabeca->nome_janela,".");
	cabeca->in.tk.jan_int = NULL;	/* a principal funciona como uma toplevel */
	cabeca->irmas = NULL;

    if( Tcl_Eval(interp,"update") != TCL_OK )
    	fprintf(stderr,"Tcl_Eval Failed: %s\n",interp->result);

}	

void do_it()  /* interp e global! */
{
	if( Tcl_Eval(interp,interp->result) != TCL_OK ) {
    	fprintf(stderr,"Tcl_Eval Failed: %s\a\n",interp->result);
		/*exit(1);*/
	}
	Tcl_ResetResult(interp);
}

int ric_getptr(char janela[],rv **aux_x,rv **ant_x)
{
	rv *aux=cabeca,*ant=cabeca;
	int das_duas_uma=0;

	while(aux) {
		if(igual(aux->nome_janela,janela)) {
			*aux_x = aux;
			*ant_x = ant;
			return das_duas_uma;
			break;
		} else {
			ant = aux;
			if(e_descendente(janela,aux->nome_janela)) {
				switch(aux->tipo_janela) {
					case MENU: 
						aux = aux->in.men.jan_int;
						break;
					case SUBMENU: 
						aux = aux->in.submen.jan_int;
						break;
					case TK:
						aux = aux->in.tk.jan_int;
						break;
					case TOPLEVEL:
						aux = aux->in.top.jan_int;
						break;
					case FRAME:
						aux = aux->in.fra.jan_int;
						break;
				}
				das_duas_uma = 1;
			} else {
				aux = aux->irmas;
				das_duas_uma = 2;
			}
		}
	}
}

void ric_garbage(rv *aux)
{
	if(aux) 
		switch(aux->tipo_janela) {
			case TK:					/* isto causa a saida do Tk */
				ric_garbage(aux->in.tk.jan_int);
				printf("removing... %s\n",aux->nome_janela);
				Tcl_AppendResult(interp,"catch {destroy ",aux->nome_janela,"} var_derro",(char *)NULL);
				do_it();
				free(aux);						/* auto-liberta-se */
				break;					/* apos remover as que de si dependem */
			case TOPLEVEL: 
				ric_garbage(aux->in.top.jan_int);
				printf("removing... %s\n",aux->nome_janela);
				Tcl_AppendResult(interp,"catch {destroy ",aux->nome_janela,"} var_derro",(char *)NULL);
				do_it();
				free(aux);						
				break;
			case FRAME:
				ric_garbage(aux->in.fra.jan_int);
				printf("removing... %s\n",aux->nome_janela);
				Tcl_AppendResult(interp,"catch {destroy ",aux->nome_janela,"} var_derro",(char *)NULL);
				do_it();
				free(aux);						
				break;
			case LISTBOX: ;			/* nao tem internas nem sera para destruir as irmas! */
			case BUTTON:
				free(aux);
				break;
			default:					/* labels e entries */
				ric_garbage(aux->irmas);
				printf("removing... %s\n",aux->nome_janela);
				Tcl_AppendResult(interp,"catch {destroy ",aux->nome_janela,"} var_derro",(char *)NULL);
				do_it();
				free(aux);					
	} else ;				/* senao nada faz */
}

void ric_clean_widgets(char janela[])
{
	rv *aux=NULL,*mae=NULL;
					/* mae nao corresponde a mae do ponto de vista do TK, mas sim a mae em termos da estrutura	*/
					/* que estou a definir, i.e. a mae e a celula que aponta directamente para a celula aux		*/
	int de_qual; 	/* indica se e para por na mae o apontador de irma a nulo ou se e para por de uma filha 	*/
					/* nao e bem assim: se for duma irma tera que ligar sim a outra caindo esta!!!				*/
					/* se for de uma filha (janelas internas) entao remove tudo que dela esta para baixo		*/
					/* e na mae desta o pointer para as internas fica agora a apontar para a irma da removida	*/
	
 	de_qual = ric_getptr(janela,&aux,&mae);
	printf("\n de_qual = %d e mae->tipo = %d\n",de_qual,mae->tipo_janela);

	if(aux && mae) 		/* so tem sentido, o que abaixo se faz, se ambas nao forem vazias!	*/
		switch(de_qual) {
			case 0:								/* esta-se em '.' donde tudo vai ser destruido excepto ela mesma! */
				ric_garbage(mae->in.tk.jan_int);
				mae->in.tk.jan_int = NULL;
												/* nao ha free pois aux = mae  e mae = '.' */
				break;
			case 1:								/* CASO: interna */
				if(mae->tipo_janela == TK)
					mae->in.tk.jan_int = aux->irmas;
				if(mae->tipo_janela == TOPLEVEL)
					mae->in.top.jan_int = aux->irmas;	/* que pode eventualmente estar a NULL	*/
				if(mae->tipo_janela == FRAME)
					mae->in.fra.jan_int = aux->irmas;	/* que pode eventualmente estar a NULL	*/
				ric_garbage(aux);				/*  remove tudo que esta dependente da janela referenciada em aux */
				free(aux);
				break;
			case 2:								/* CASO: irma */
				mae->irmas = aux->irmas;		/* dai se impor que aux != NULL	*/
				ric_garbage(aux);				/* remove tudo que esta dependente da janela referenciada em aux */
				free(aux);
				break;
		}
}



/* vc - guarda o texto da label no caso da widget ser uma label 
   vc - guarda o titulo da toplevel caso da widget ser uma toplevel ou menu
   caso seja 'listbox' vc = var_camila 
					   vtcl = titulo-x
					   ve = tamanho-x
					   tr = tamanho-y (ou numero de linhas) 
					   tamanho = NULL e insert_type = LISTBOX 
	caso seja 'button' vc = var_camila
					   vtcl = titulo	
	CUIDADO: var_cam ja nao existe, mas vc sim! */
void ric_append_widget(char nw[],char vc[],char vtcl[],char ve[],char tr[],char tamanho[],int insert_type,SEXP sexp)
{
	rv *lixo=NULL,*lixa=NULL;

	ric_getptr(nw,&lixo,&lixa);

	if(insert_type == OPCAO && lixo) { 	/* ha que ter cuidado */
		sprintf(nw,"%s%d",nw,contador++);
		ric_append_widget_aux(nw,vc,vtcl,ve,tr,tamanho,insert_type,sexp);
	} 	

	if(lixo && insert_type != OPCAO) printf("Window '%s' already exists!\n\a",nw); 
	if(!lixo) ric_append_widget_aux(nw,vc,vtcl,ve,tr,tamanho,insert_type,sexp);
}

void ric_append_widget_aux(char nw[],char vc[],char vtcl[],char ve[],char tr[],char tamanho[],int insert_type,SEXP sexp)
{
	rv *ptr,*aux=cabeca,*ant;
	int tipo_ret=0,das_duas_uma=0;



	/*strcpy(janela_mae,ric_father(nw));	 da o nome da janela mae da widget a criar e a introduzir */

	ptr = (rv *)malloc(sizeof(rv));

	ptr->tipo_janela=insert_type;
	strcpy(ptr->nome_janela,nw);

	switch(insert_type) {
		case ENTRY:
			if(tr && igual(tr,"INT")) tipo_ret=INT;
			if(tr && igual(tr,"STR")) tipo_ret=STR;
			
			strcpy(ptr->in.ent.var_tcl,vtcl);
			strcpy(ptr->in.ent.var_enter,ve);
			ptr->in.ent.tipo_ret = tipo_ret;
			strcpy(ptr->in.ent.tam_entry,tamanho);
			break;
		case LISTBOX:
			strcpy(ptr->in.box.titulo,vtcl);
			strcpy(ptr->in.box.tamanho_x,ve);
			strcpy(ptr->in.box.tamanho_y,tr);
			break;
		case TK_LABEL:
			strcpy(ptr->in.lab.texto_label,vc);
			break;
		case BUTTON:
			strcpy(ptr->in.but.nome_botao,vtcl);
			sprintf(ptr->in.but.tamanho,"%d",strlen(vtcl)+4);	/* para ter largeza */
			break;
		case FRAME: 
			ptr->in.fra.jan_int = NULL;
			break; 	
		case TOPLEVEL:
			strcpy(ptr->in.top.titulo,vc);
			strcpy(ptr->in.top.tamanho_x,vtcl);
			strcpy(ptr->in.top.tamanho_y,ve);
			ptr->in.top.jan_int = NULL;
			break; 	
		case MENU:
 			strcpy(ptr->in.men.titulo,vc);
			strcpy(ptr->in.men.tamanho_x,vtcl);
			strcpy(ptr->in.men.tamanho_y,ve);
			ptr->in.men.jan_int = NULL;
			break;
		case SUBMENU:
			ptr->in.submen.jan_int = NULL;
			strcpy(ptr->in.submen.nome_visivel,vc);
			break;
		case OPCAO: 
			strcpy(ptr->in.opcao.nome_visivel,vc);	/* para ja' fica assim!	*/
			ptr->in.opcao.to_execute = sexp;		/* o parametro sexp e' aqui usado */
			break;
	}
	ptr->irmas = NULL;			/* ate aqui criou-se a nova celula ja com as informacoes desejadas */

 /* agora ha que procurar o sitio onde meter a nova celula criada */

	if(cabeca->in.tk.jan_int == NULL) 
		cabeca->in.tk.jan_int = ptr;
	else {
		aux = cabeca->in.tk.jan_int;
		while(aux) {
			ant = aux;
			if(e_descendente(nw,aux->nome_janela)) {
				switch(aux->tipo_janela) {
					case MENU:
						aux = aux->in.men.jan_int;
						break;
					case SUBMENU:
						aux = aux->in.submen.jan_int;
						break;
					case TOPLEVEL:
						aux = aux->in.top.jan_int;
						break;
					case FRAME:
						aux = aux->in.fra.jan_int;
						break;
				}
				das_duas_uma = 1;
			} else { 					/* procura nas irmas */
				aux = aux->irmas;
				das_duas_uma = 2;
			}
		}
		switch(das_duas_uma) {
			case 1: 					
				if(ant->tipo_janela == MENU)
					ant->in.men.jan_int = ptr;
				if(ant->tipo_janela == SUBMENU)
					ant->in.submen.jan_int = ptr;
				if(ant->tipo_janela == TOPLEVEL)
					ant->in.top.jan_int = ptr;
				if(ant->tipo_janela == FRAME)
					ant->in.fra.jan_int = ptr;
				break;
			case 2:
				ant->irmas = ptr;
				break;
		}
	}
}

void ric_show(rv *aux)
{ 
	if(aux)				/*	 se nao vazio */
		switch(aux->tipo_janela) {

			case TK:
				printf("end = %x tipo = %d widget = %s\n",aux,aux->tipo_janela,aux->nome_janela);
				printf("\t\t interna = %x irma = %x\n",aux->in.tk.jan_int,aux->irmas);
				ric_show(aux->in.tk.jan_int);
				break;
			case MENU:
				printf("end = %x tipo = %d widget = %s tit = %s\n",aux,aux->tipo_janela,aux->nome_janela,aux->in.men.titulo);
				printf("\t\t interna = %x irma = %x\n",aux->in.men.jan_int,aux->irmas);
				ric_show(aux->in.men.jan_int);
				ric_show(aux->irmas);
				break;
			case SUBMENU:
				printf("end = %x tipo = %d widget = %s nome = %s\n",aux,aux->tipo_janela,aux->nome_janela,aux->in.submen.nome_visivel);
				printf("\t\t interna = %x irma = %x\n",aux->in.submen.jan_int,aux->irmas);
				ric_show(aux->in.submen.jan_int);
				ric_show(aux->irmas);
				break;
			case OPCAO:
				printf("end = %x tipo = %d widget = %s opcao = %s irma = %x\n",aux,aux->tipo_janela,aux->nome_janela,aux->in.opcao.nome_visivel,aux->irmas);
				printf("\t\t sexp = %x\n",aux->in.opcao.to_execute);
				ric_show(aux->irmas);
				break;
			case TOPLEVEL: ;
				printf("end = %x tipo = %d widget = %s tit = %s\n",aux,aux->tipo_janela,aux->nome_janela,aux->in.top.titulo);
				printf("\t\t interna = %x irma = %x\n",aux->in.top.jan_int,aux->irmas);
				ric_show(aux->in.top.jan_int);
				ric_show(aux->irmas);
				break; 
			case FRAME:
				printf("end = %x tipo = %d widget = %s\n",aux,aux->tipo_janela,aux->nome_janela);
				printf("\t\t interna = %x irma = %x\n",aux->in.fra.jan_int,aux->irmas);
				ric_show(aux->in.fra.jan_int);
				ric_show(aux->irmas);
				break; 
			case TK_LABEL:
				printf("end = %x tipo = %d widget = %s irma = %x v=%s\n",aux,aux->tipo_janela,aux->nome_janela,aux->irmas,aux->in.lab.texto_label);
				ric_show(aux->irmas);
				break;
			case ENTRY:
				printf("end = %x tipo = %d wiDget = %s tamanho =%s irma = %x\n",aux,aux->tipo_janela,aux->nome_janela,aux->in.ent.tam_entry,aux->irmas);
				ric_show(aux->irmas);
				break;
			case LISTBOX:
				printf("end = %x tipo = %d widget = %s titulo = %s\n\t\t irma = %x\n",aux,aux->tipo_janela,aux->nome_janela,aux->in.box.titulo,aux->irmas);
				ric_show(aux->irmas);
				break;

            case BUTTON:
                /*printf("end = %x tipo = %d widget = %s funcao = %s irma = %x\n",aux,aux->tipo_janela,aux->nome_janela,aux->in.but.funcao,aux->irmas);*/
                printf("end = %x tipo = %d widget = %s irma = %x\n",aux,aux->tipo_janela,aux->nome_janela,aux->irmas);
                ric_show(aux->irmas);
                break;

			default:			/*	 labels */
				printf("end = %x tipo = %d widget = %s irma = %x\n",aux,aux->tipo_janela,aux->nome_janela,aux->irmas);
				ric_show(aux->irmas);
		}
	else ;			/*	 senao nada faz */
}	

char *nome_dum_simbolo(SEXP s)
{
	if(s && s->n_type == SYM && s->n_info.n_xsym.xsy_value && s->n_info.n_xsym.xsy_value->n_type == STR) 
        return s->n_info.n_xsym.xsy_value->n_info.n_xstr.xst_str;	
	else return "";
}

char *ric_generic(SEXP s,int tipo)
{
	rv *lixo1=NULL,*lixo2=NULL,*lixo3=NULL;		/* util para opcao e submenus */
    SEXP aux,x;
	int where_from=1; /* 0 se veio via simbolo do camila 1 senao! */
	char  tamanho_x[5],tamanho_y[5];
    char nome_parente[50],nome_actual[50],titulo[50],nome_completo[50];
			 /* titulo guarda o nome do botao no caso de ser botao */

    strcpy(nome_parente,"");
    strcpy(nome_actual,"");
    strcpy(titulo,"");
	strcpy(tamanho_x,"0");
	strcpy(tamanho_y,"0");

    if( Tk_Init(interp) == TCL_ERROR ) {
        fprintf(stderr, "Tk_Init failed:  %s\n", interp->result);
        exit(1);
    }
    forall(aux,x,s)
        switch(x->n_type) {
            case STR:
                if(igual(nome_parente,"")) {strcpy(nome_parente,x->n_str); break;}
                if(igual(nome_actual,"")) {

						strcpy(titulo,x->n_str);			/*    Isto acho que se pode apagar!!! */
						sprintf(nome_actual,"_%s",titulo);	/*  Sera'?? ver comentario abaixo */

						ric_join(nome_actual);	/* util para botoes?? junta o titulo e faz de nome */
						break;
				} else strcpy(titulo,x->n_str);	/* isto funciona caso das tops e menus */
				
                break;   /* break anyway! */
			case SYM:
				if(igual(nome_parente,"")) {
					strcpy(nome_parente,nome_dum_simbolo(x));
					where_from=!where_from;
				} 
				break;
			case INT:
				if(tipo == TOPLEVEL || tipo == MENU) {	/* so' tem valia para menus ou tops */
					if(igual(tamanho_x,"0")) sprintf(tamanho_x,"%d",x->n_int);
					else sprintf(tamanho_y,"%d",x->n_int);
				} else {
					fprintf(stderr,"Ric_generic error: dimentions definition denied! \n\a",x->n_type);
				}
				break;
			case LIST:
				if(tipo == OPCAO) break; /* nao discute e' que opcao tem no terceiro argumento uma sexp i.e. LIST */
										 /* senao faz o aviso por default */
			default:
				fprintf(stderr,"Ric_generic error: found type %d.\n\a",x->n_type);
				break;
        }

	if(where_from) 
		if(!igual(nome_parente,".")) 
    		sprintf(nome_completo,"._%s.%s",nome_parente,nome_actual);
		else
    		sprintf(nome_completo,"%s%s",nome_parente,nome_actual);
	else		/* se veio via simbolo do camila */
		sprintf(nome_completo,"%s.%s",nome_parente,nome_actual);
	switch(tipo) {
		case TOPLEVEL:
    		ric_append_widget(nome_completo,titulo,tamanho_x,tamanho_y,NULL,NULL,TOPLEVEL,NULL);
			break;
		case FRAME:
            ric_append_widget(nome_completo,NULL,NULL,NULL,NULL,NULL,FRAME,NULL);			
			break;
		case BUTTON:
			ric_append_widget(nome_completo,NULL,titulo,NULL,NULL,NULL,BUTTON,NULL);
			break;
		case MENU:
			ric_append_widget(nome_completo,titulo,tamanho_x,tamanho_y,NULL,NULL,MENU,NULL);
			break;
		case SUBMENU:
/*
			ric_getptr(ric_father(nome_completo),&lixo1,&lixo2);
			if(lixo1 && lixo1->tipo_janela == SUBMENU)  	 se a anterior e' um submenu ... 
				sprintf(nome_completo,"%s.m.%s",nome_parente,nome_actual);
*/
			ric_append_widget(nome_completo,titulo,NULL,NULL,NULL,NULL,SUBMENU,NULL);
			break;
		case OPCAO:
/*
			ric_getptr(ric_father(nome_completo),&lixo1,&lixo2);
			if(lixo1) ric_getptr(ric_father(lixo1->nome_janela),&lixo3,&lixo2);
			if(lixo3 && lixo3->tipo_janela == SUBMENU) {
				printf("submenu de submenu\n\n");
*/
			sprintf(nome_completo,"%s.m",nome_parente);
			ric_append_widget(nome_completo,titulo,NULL,NULL,NULL,NULL,OPCAO,get3(s) != XM_ERROR ? get3(s) : NULL);	/* get3(s) tem a 'sexp' a invocar 	  */
			break;																		/* pode ser uma sexp vazia (XM_ERROR) */
		default:
			fprintf(stderr,"ric_generic error: unknown type %d\a\n",tipo);
			exit(1);
	}	
	return nome_completo;
}


/* esta funcao vai activar (pack & bind) os objectos Tk criados */
void ric_activate2(rv *aux) 
{
	rv *lixo1=NULL,*lixo2=NULL;
	if(aux)		/* se nao vazio */
		switch(aux->tipo_janela) {
			case TOPLEVEL:
				Tcl_AppendResult(interp,"toplevel ",aux->nome_janela,(char *)NULL); do_it();
				Tcl_AppendResult(interp,"wm title ",aux->nome_janela," \"",aux->in.top.titulo,"\"",(char *)NULL); do_it();

				if(!igual(aux->in.top.tamanho_x,"0") && !igual(aux->in.top.tamanho_y,"0"))
					Tcl_AppendResult(interp,"wm geometry ",aux->nome_janela," ",aux->in.top.tamanho_x,"x",aux->in.top.tamanho_y,(char *)NULL); do_it();
                ric_activate2(aux->in.top.jan_int);		/* agora vai activar as de si dependentes */
				break;
			case FRAME:
            	Tcl_AppendResult(interp,"frame ",aux->nome_janela,(char *)NULL); do_it();
            	Tcl_AppendResult(interp,"pack ",aux->nome_janela,(char *)NULL); do_it();
				ric_activate2(aux->in.fra.jan_int);		/* agora vai activar as de si dependentes */
				break;
			case TK_LABEL:
				Tcl_AppendResult(interp,"label ",aux->nome_janela," -text \"",aux->in.lab.texto_label,"\"",(char *)NULL); do_it(); 
                Tcl_AppendResult(interp,"pack ",aux->nome_janela," -padx 4m -pady 1m -expand yes",(char *)NULL); do_it();
				ric_activate2(aux->irmas);				/* vai acordar as irmas	*/
				break;
			case ENTRY:
				Tcl_AppendResult(interp,"entry ",aux->nome_janela," -width ",aux->in.ent.tam_entry," -relief sunken "," -textvariable ",aux->in.ent.var_tcl,(char *)NULL); do_it();
                Tcl_AppendResult(interp,"pack ",aux->nome_janela," -padx 4m -pady 1m -expand yes",(char *)NULL); do_it();
        		Tcl_AppendResult(interp,"bind ",aux->nome_janela," <Return>"," {set ", aux->in.ent.var_enter," 1}",(char *)NULL); do_it();
				ric_activate2(aux->irmas);				/* vai acordar as irmas	*/
				break;
			case BUTTON:
				Tcl_AppendResult(interp,"button ",aux->nome_janela," -width ",aux->in.but.tamanho," -text \"",aux->in.but.nome_botao,"\"",(char *)NULL); do_it();
				Tcl_AppendResult(interp,"pack ",aux->nome_janela," -padx 4m -pady 1m -expand yes",(char *)NULL); do_it();
				break;
			case LISTBOX:

				Tcl_AppendResult(interp,"frame ",aux->nome_janela,(char *)NULL); do_it();
				Tcl_AppendResult(interp,"pack ",aux->nome_janela,(char *)NULL); do_it();
				Tcl_AppendResult(interp,"label ",aux->nome_janela,".help -text \"",aux->in.box.titulo,"\"",(char *)NULL); do_it();
				Tcl_AppendResult(interp,"scrollbar ",aux->nome_janela,".scroll1 -relief sunken -command \"",aux->nome_janela,".list yview\"",(char *)NULL); do_it();
				Tcl_AppendResult(interp,"scrollbar ",aux->nome_janela,".scroll2 -orient horiz -relief sunken -command \"",aux->nome_janela,".list xview\"",(char *)NULL); do_it();
				Tcl_AppendResult(interp,"listbox ",aux->nome_janela,".list -geometry ",aux->in.box.tamanho_x,"x",aux->in.box.tamanho_y," -yscroll \"",aux->nome_janela,".scroll1 set\" -relief sunken -setgrid 1 -xscroll \"",aux->nome_janela,".scroll2 set \" -relief sunken -setgrid 1",(char *)NULL); do_it();

				Tcl_AppendResult(interp,"pack ",aux->nome_janela,".help",(char *)NULL); do_it();
				Tcl_AppendResult(interp,"pack ",aux->nome_janela,".scroll1 -side right -fill y",(char *)NULL); do_it();
				Tcl_AppendResult(interp,"pack ",aux->nome_janela,".list -expand yes -fill both",(char *)NULL); do_it();
				Tcl_AppendResult(interp,"pack ",aux->nome_janela,".scroll2 -fill x",(char *)NULL); do_it();
				break;
			case MENU:
				Tcl_AppendResult(interp,"toplevel ",aux->nome_janela,(char *)NULL); do_it();
				Tcl_AppendResult(interp,"wm title ",aux->nome_janela," \"",aux->in.men.titulo,"\"",(char *)NULL); do_it();

				if(!igual(aux->in.men.tamanho_x,"0") && !igual(aux->in.men.tamanho_y,"0"))
					Tcl_AppendResult(interp,"wm geometry ",aux->nome_janela," ",aux->in.men.tamanho_x,"x",aux->in.men.tamanho_y,(char *)NULL); do_it();
				ric_activate2(aux->in.men.jan_int);
				break;
			case SUBMENU:
				ric_getptr(ric_father(aux->nome_janela),&lixo1,&lixo2);
/*
				if(lixo1 && lixo1->tipo_janela == SUBMENU) {
					Tcl_AppendResult(interp,"catch {menubutton ",lixo1->nome_janela," -text \"",lixo1->in.submen.nome_visivel,"\" -menu ",aux->nome_janela,"}",(char *)NULL); do_it();
 					Tcl_AppendResult(interp,"catch {menu ",ric_tira_cont(aux->nome_janela),"}",(char *)NULL); do_it();
					Tcl_AppendResult(interp,ric_tira_cont(aux->nome_janela)," add cascade -label \"",aux->in.submen.nome_visivel,"\"",(char *)NULL); do_it();
					
				}
*/

				ric_activate2(aux->in.submen.jan_int);			/* primeiro activa as filhas que sao as que criam esta! */
				Tcl_AppendResult(interp,"catch {pack ",aux->nome_janela,"}",(char *)NULL); do_it();
				ric_activate2(aux->irmas);	/* e' estranho mas este tipo de widget tem de acordar as suas filhas e irmas */
				break;
			case OPCAO:
				ric_getptr(ric_father(aux->nome_janela),&lixo1,&lixo2);

				Tcl_AppendResult(interp,"catch {menubutton ",lixo1->nome_janela," -text \"",lixo1->in.submen.nome_visivel,"\" -menu ",aux->nome_janela,"}",(char *)NULL); do_it();
				Tcl_AppendResult(interp,"catch {menu ",ric_tira_cont(aux->nome_janela),"}",(char *)NULL); do_it();
				Tcl_AppendResult(interp,ric_tira_cont(aux->nome_janela)," add command -label \"",aux->in.opcao.nome_visivel,"\" -command \"tkcom_opcao ",aux->nome_janela,"\"",(char *)NULL);
				do_it();
				ric_activate2(aux->irmas);
				break;	
		}
}

void ric_deactivate_aux(rv *aux)
{
    if(aux)
        switch(aux->tipo_janela) {
            case TK:
                ric_deactivate_aux(aux->in.tk.jan_int);
                printf("deactivate... %s\n",aux->nome_janela);
                Tcl_AppendResult(interp,"catch {destroy ",aux->nome_janela,"} var_derro",(char *)NULL);
                do_it();
                break;
            case TOPLEVEL:
                ric_deactivate_aux(aux->in.top.jan_int);
                printf("deactivate... %s\n",aux->nome_janela);
                Tcl_AppendResult(interp,"catch {destroy ",aux->nome_janela,"} var_derro",(char *)NULL);
                do_it();
                break;
            case FRAME:
                ric_deactivate_aux(aux->in.fra.jan_int);
                printf("deactivate... %s\n",aux->nome_janela);
                Tcl_AppendResult(interp,"catch {destroy ",aux->nome_janela,"} var_derro",(char *)NULL);
                do_it();
                break;
            case ENTRY:
                ric_deactivate_aux(aux->irmas);
                printf("deactivate... %s\n",aux->nome_janela);
                Tcl_AppendResult(interp,"catch {destroy ",aux->nome_janela,"} var_derro",(char *)NULL);
                do_it();
				Tcl_UnsetVar(interp,aux->in.ent.var_tcl,NULL);
                Tcl_UnsetVar(interp,aux->in.ent.var_enter,NULL);    /* e imprescindivel para que seja possivel ler de novo */
                break;
			case BUTTON: ;		/* para ja faz o mesmo que por defeito */
            default:                    /* labels por ex. */
                ric_deactivate_aux(aux->irmas);
                printf("deactivate... %s\n",aux->nome_janela);
                Tcl_AppendResult(interp,"catch {destroy ",aux->nome_janela,"} var_derro",(char *)NULL);
                do_it();
        }
    else ;  /* nao faz nada! */
}


void ric_escreve_listbox_aux(SEXP s,rv *listbox) /* so aceita para input na listbox INT ou STR, */
{                                                /* pelo menos para ja */
    char intstr[10];
    switch(s->n_type) {
        case INT:
            sprintf(intstr,"%d",s->n_int);
            Tcl_AppendResult(interp,listbox->nome_janela,".list insert 0 \"",intstr,"\"",(char *)NULL); do_it();
            break;
        case STR:
            Tcl_AppendResult(interp,listbox->nome_janela,".list insert 0 \"",s->n_str,"\"",(char *)NULL); do_it();
            break;
        default:
            fprintf(stderr,"Rwlb error 2! This shouldn't never happen! I found type %d\nPlease contact your drug dealler...\n\a");

    }
}


/* --------------------- fim --------------------------------- */

/* -------------------- funcoes para camila ------------------ */

SEXP ric_destroy(SEXP s)
{
	char nome_form[50];

	if(s && s->n_type==LIST) {
		strcpy(nome_form,nome_dum_simbolo(s->n_info.n_xlist.xl_value));
		if(!igual(nome_form,"")) 
			ric_clean_widgets(nome_form); /* recebe o nome da janela a partir da qual vai haver destruicao */
		else fprintf(stderr,"\a\n Destroy error: symbol not found!\n");
	 } else 
		fprintf(stderr,"\a\n Destroi error: sexp mistaken!\n");
	return NULL;	/* ao retornar NULL se em camila se fizer FORM <- destroi(FORM) esta e' eliminada */
}


SEXP ric_deactivate(SEXP s)
{
	char nome_form[50];
	rv *aux=NULL,*ant=NULL; 

	if(s && s->n_type==LIST) {
		strcpy(nome_form,nome_dum_simbolo(s->n_info.n_xlist.xl_value));	
		if(!igual(nome_form,"")) {
			ric_getptr(nome_form,&aux,&ant); 					/* anterior nao tem interesse, mas e' uma mal */
																/* necessario para usar ric_getptr */
			ric_deactivate_aux(aux);
		} else fprintf(stderr,"\a\n Desactiva error: symbol not found!\n");
	 } else 
		fprintf(stderr,"\a\n Desactiva error: sexp mistaken!\n");
	return NULL;
}

SEXP ric_activate(SEXP s) /* para usar aquando da activacao em uso posterior de uma form criada */
{
	char nome_form[50];
	rv *aux=NULL,*ant=NULL;

	signal(SIGALRM,ric_alrm); 	  /* para perceber por que isto aqui esta consulte-se I_exe_but	*/
	alarm(1);				  /* reinstalacao do alarm */

	if(s && s->n_type==LIST) {
		strcpy(nome_form,nome_dum_simbolo(s->n_info.n_xlist.xl_value));	
		if(!igual(nome_form,"")) {
			ric_getptr(nome_form,&aux,&ant);	/* ant nao tem qualquer interesse, somente possibilita */ 
												/* o uso da funcao ric_getptr */ 
				ric_activate2(aux);
		} else {
			fprintf(stderr,"\a\n Activa error: symbol not found!\n");
		}
	} else 
		fprintf(stderr,"\a\n Activa error: sexp mistaken!\n");

	return NULL;
}


/* sintaxe: rgve2 [widget_mae] ([tam] tipo nome_label)+   */
SEXP ric_get_value_entry2(SEXP s)
{
	SEXP aux,x;
	char nome_label[50],nome_entry[50],tam_entry[6],nome_tv[50],houve_enter[50],auxiliar[5]; 
									/* auxiliar tem o tipo a retornar */
	char nome_label_v[50]; 			/* tem o nome da label visivel, i.e. o que o utilizador escreve, portanto */ 
	char widget_mae[50],xx[50];		/* sem o "contador" */

    if( Tk_Init(interp) == TCL_ERROR ) {
        fprintf(stderr, "Tk_Init failed:  %s\a\n", interp->result);
        exit(1);
    }
	strcpy(widget_mae,"");
	strcpy(tam_entry,"0");
	strcpy(auxiliar,"");

	forall(aux,x,s) 
		switch(x->n_type) {
			case SYM:
                if(igual(widget_mae,"")) 
					if(igual(strcpy(widget_mae,nome_dum_simbolo(x)),"")) 	/* i.e. se vier INT ou STR e nao o */
																			/*  desejado simbolo que referencia */
																			/* uma janela TK */
						strcpy(widget_mae,".");							/* a janela mae e' a por defeito '.'*/
					else
						sprintf(widget_mae,"%s.",widget_mae);

				else {
					if(igual(auxiliar,"")) { 				/* vai-se definir o tipo a retornar */
						strcpy(auxiliar,x->n_symname); 
						switch(igual(tam_entry,"0")) {
							case TRUE:						/* e especificar os valores p/ defeito */
								if(igual(auxiliar,"STR"))
									strcpy(tam_entry,"30");
								if(igual(auxiliar,"INT"))
									strcpy(tam_entry,"10"); 
								break;   
							case FALSE: break;				/* ou os valores ja sao conhecidos! */
						}
					} 
				}
				break;
			case STR:
				sprintf(nome_label_v,x->n_str);
				strcpy(xx,nome_label_v);
				ric_join(xx);					/* uso o 'xx' porque nao posso fazer sprintf de nome_label para */
				sprintf(houve_enter,"%she%s%d",widget_mae,xx,contador); /* ele mesmo com mais uma formatos %s... */
																		/* pelo meio... enfim mais 	*/
				sprintf(nome_entry,"%se%s%d",widget_mae,xx,contador);	/* um bug que nao domino! Por ex. nos */ 
																		/* outputs tenho um ex. q funciona */
				sprintf(nome_tv,"tv%s%d",xx,contador);
				sprintf(nome_label,"%sl%s%d",widget_mae,xx,contador);   /* tem de ser por esta ordem senao ha */
																		/* espiga! */

				ric_append_widget(nome_label,nome_label_v,NULL,NULL,NULL,NULL,TK_LABEL,NULL);  /* vai meter na lista */ 
				ric_append_widget(nome_entry,NULL,nome_tv,houve_enter,auxiliar,tam_entry,ENTRY,NULL); /* das widgets */
																						 /* a label e a entry   */

				strcpy(auxiliar,""); 	/* limpa para esperar nova entry, etc */
				strcpy(tam_entry,"0"); 	/* para que no proxima vez continue a ser verdadeira a condicao! */
				contador++; 
				break;
			case INT:
				if(igual(widget_mae,""))
					strcpy(widget_mae,".");
				sprintf(tam_entry,"%d",x->n_int);
				break;
		}
	return(strsexp(nome_entry));
}


SEXP le(SEXP s)
{
	rv *aux=NULL,*ant=NULL;

	if(s && s->n_type == LIST) {
		s = s->n_info.n_xlist.xl_value;
		if(s && s->n_type == SYM && s->n_symvalue->n_type == STR)
			ric_getptr(s->n_symvalue->n_str,&aux,&ant);	/* espera-se que aux fique a apontar para a */
														/* celula que tem o nome igual ao valor do simbolo */
													/* que ele recebeu; s->...->n_str tera o nome da janela	*/
		else {
            fprintf(stderr,"Le error2: found type %d. Expected SYM=3\n");
            return NULL;
		}
	} else {
    	fprintf(stderr,"Le error1: found type %d. Expected LIST=2\n");
        return NULL;
	}

	if(aux && aux->tipo_janela == ENTRY) {		/* este teste ate e forte demais, mas... fica! */

		Tcl_AppendResult(interp,"focus ",aux->nome_janela,(char *)NULL);
		do_it();	
		while(!(Tcl_GetVar(interp,aux->in.ent.var_enter,NULL)))
			Tcl_GetVar(interp,aux->in.ent.var_tcl,NULL);
		switch(aux->in.ent.tipo_ret) {
			case INT:
				return(intsexp(atoi(Tcl_GetVar(interp,aux->in.ent.var_tcl,NULL))));
				break;
			case STR:
				return(strsexp(Tcl_GetVar(interp,aux->in.ent.var_tcl,NULL)));
				break;
			default:
				fprintf(stderr,"Le error3: unknown return type %d\a\n",aux->in.ent.tipo_ret);
				return NULL;
		}
	}
}

SEXP trata_sexp(SEXP x)
{
    if(x)
        switch(x->n_type) {
            case INT:
                return intsexp(x->n_int);
                break;
            case STR:
                return strsexp(x->n_str);
                break;
            case SYM:
                return symsexp(x->n_symname);
                break;
            case LIST:
                return (conssexp(trata_sexp(x->n_head),x->n_tail));
        }
    else return NULL;
}

SEXP escreve(SEXP s)
{
	rv *aux=NULL,*ant=NULL;
	SEXP sexp1,sexp2,res=NULL;
	char output_value[100],intstr[10];

	if(s && s->n_type == LIST) {
		sexp1 = get1(s); sexp2 = get2(s);	
		
		if(sexp2 && sexp2->n_type == LIST) {		/* recebeu uma 'sexp'	*/
			res = xleval(trata_sexp(sexp2));
			if(res)                         /* sempre era uma 'sexp' que foi recebida no segundo arg. */
                switch(res->n_type) {
                    case INT:
                        sprintf(output_value,"%d",res->n_int);
                        break;
                    case STR:
                        strcpy(output_value,res->n_str);
                        break;
                    default:
                        fprintf(stderr,"Escreve error5: second argument eval return %d!\n\a",res->n_type);
                        strcpy(output_value,"");
                }
		}

		if(sexp1 && sexp1->n_type == SYM && sexp1->n_symvalue->n_type == STR) {

			ric_getptr(sexp1->n_symvalue->n_str,&aux,&ant);	

			if(sexp2->n_type == SYM) 					/* se recebeu um 'sym' e nao uma 'sexp'	*/
				switch(sexp2->n_symvalue->n_type) {
					case INT:
						sprintf(output_value,"%d",sexp2->n_symvalue->n_int);
						break;
					case STR:
						strcpy(output_value,sexp2->n_symvalue->n_str);
						break;
					default:
   	    	 			fprintf(stderr,"Escreve error3: second argument must reference a INT or STR value!\n\a");
						strcpy(output_value,"");
				}
		} else fprintf(stderr,"Escreve error2: wrong types!\n\a");
	} else fprintf(stderr,"Escreve error1: found type %d. Expected two elements LIST=2\n");

	if(aux && aux->tipo_janela == ENTRY && !igual(output_value,"")) {
        switch(aux->in.ent.tipo_ret) {					/* espera-se contudo que o tipo a retornar 	*/
            case INT: ;									/* coincida com o tipo da sexp2!			*/
            case STR:
                Tcl_SetVar(interp,aux->in.ent.var_tcl,output_value,NULL);
                break;
            default:
                Tcl_SetVar(interp,aux->in.ent.var_tcl,"Unknown value",NULL);
        }
    } else fprintf(stderr,"Escreve error4: symbol doesn't match any window variable. \n");
   	return NULL;
}

SEXP ric_escreve_listbox(SEXP s) 
{
	rv *ant,*aux;
	SEXP sexp1,sexp2,res;

	sexp1 = get1(s);
	sexp2 = get2(s);


	if(sexp1 != XM_ERROR && sexp1->n_symvalue && sexp1->n_symvalue->n_type == STR)	/* tera em principio o sym com o nome do listbox... */
		ric_getptr(sexp1->n_symvalue->n_str,&aux,&ant);								/* aux ficara com o end. da widget listbox 	*/
 	else 
		fprintf(stderr,"Rwlb error 1: symbol not found!\n\a");

	if(sexp2 != XM_ERROR)  	/* aguardo uma 'sexp' */
		res = xleval(trata_sexp(sexp2));
	else 
		fprintf(stderr,"Rwlb error 2: 'sexp' is invalid!\n\a");

	if(res)				/* fez bem o eval... */
		ric_escreve_listbox_aux(res,aux);
	else 
		fprintf(stderr,"Rwlb error 3: 'sexp' eval return error!\n\a");

	return NULL;
}


SEXP ric_make_button(SEXP s)
{
	return strsexp(ric_generic(s,BUTTON));
    /*return NULL;*/
}

SEXP ric_top_level(SEXP s)
{
	return strsexp(ric_generic(s,TOPLEVEL));
}

SEXP ric_frame(SEXP s)
{
	return strsexp(ric_generic(s,FRAME));
}

SEXP ric_listbox(SEXP s)
{
	SEXP aux,x; 
	int where_from=1; /* 0 se veio via simbolo do camila 1 senao! */
	char nome_completo[50];
	char nome_parente[50],nome_actual[50],titulo[50]; /* o titulo e' facultativo ou pode ser */
													  /* dado 'a toplevel envolvente, se existir */
	strcpy(nome_parente,"");
	strcpy(nome_actual,"");
	strcpy(titulo,"");
	
	if(s && s->n_type == LIST) {
		forall(aux,x,s)
			switch(x->n_type) {
				case STR:
					if(igual(nome_parente,"")) {strcpy(nome_parente,x->n_str); break;}
					if(igual(nome_actual,"")) {
						sprintf(nome_actual,"_%s",x->n_str);
						break;
					} else strcpy(titulo,x->n_str);		/* caso haja titulo */
					break; 
				case SYM:
					if(igual(nome_parente,"")) {
						strcpy(nome_parente,nome_dum_simbolo(x));
						where_from=!where_from;
					}
					break;
			}
		if(where_from)
			if(!igual(nome_parente,"."))
				sprintf(nome_completo,"._%s.%s",nome_parente,nome_actual);
			else
				sprintf(nome_completo,"%s%s",nome_parente,nome_actual);
		else		/* se veio via simbolo do camila */
			sprintf(nome_completo,"%s.%s",nome_parente,nome_actual);

		ric_append_widget(nome_completo,NULL,titulo,"50","10",NULL,LISTBOX,NULL);
		return strsexp(nome_completo);
	} else {
		fprintf(stderr,"Rlbx error: sexp mistaken!\n\a");
		return NULL;
	}
}

SEXP ric_menu(SEXP s)
{
    return strsexp(ric_generic(s,MENU));
}

SEXP ric_submenu(SEXP s)
{
    return strsexp(ric_generic(s,SUBMENU));
}

SEXP ric_opcao(SEXP s)
{
    return strsexp(ric_generic(s,OPCAO));
}

SEXP ric_attrib_bind(SEXP s)
{
	rv *ant=NULL,*aux=NULL;
	char sym[50];		
	SEXP auxiliar,x,sexp1,sexp2;

	if(s && s->n_type == LIST) {
		sexp1 = get1(s); sexp2 = get2(s);
		if(sexp1 && sexp1->n_type == SYM && sexp1->n_symvalue && sexp1->n_symvalue->n_type == STR) {	/* recebeu um simbolo que contem o nome do botao */
			ric_getptr(sexp1->n_symvalue->n_str,&aux,&ant);		
		} else
			fprintf(stderr,"Rab error 2: ...\n\a");

		if(sexp2 && (sexp2->n_type == LIST || sexp2->n_type == SYM)) {	/* recebeu uma 'sexp' */
			if(aux && aux->tipo_janela == BUTTON) {
				aux->in.but.evento = sexp2;
				Tcl_AppendResult(interp,"bind ",aux->nome_janela," <Button-1> {tkcom_exe_but ",aux->nome_janela,"}",(char *)NULL);
				do_it();
			} else {
				fprintf(stderr,"Rab error 3: button not found!\n\a");
			}
		} else 
			fprintf(stderr,"Rab error 4: trouble on 'sexp'!\n\a");
	} else fprintf(stderr,"Rab error 1: ...\n\a");
	return NULL;

}

/* ------------------------------- Outputs ---------------------------------*/
/* ------------------ Configure functions ------------------------- */

SEXP ric_config_widget(SEXP s)
{
	SEXP aux,x;
	char widget_a_cfg[50],opcao_cfg[20],novo_valor[20];
	
	strcpy(widget_a_cfg,"");

	forall(aux,x,s)
		switch(x->n_type) {
			case STR:
				if(igual(widget_a_cfg,"")) {
					sprintf(widget_a_cfg,".%s",x->n_str);
					break;
				}
				if(igual(opcao_cfg,"")) {
					sprintf(opcao_cfg,"-%s",x->n_str); /* ex: -width ... */
					break;
				} 
				if(igual(novo_valor,"")) {
					strcpy(novo_valor,x->n_str);
					break;
				}
			case INT:
				if(igual(novo_valor,"")) {
					sprintf(novo_valor,"%d",x->n_int);
					break;
				}
			default:
				fprintf(stderr,"rcfgw error: unexpected type %d!\n\a",x->n_type);
				return NULL;
		} 

	Tcl_AppendResult(interp,widget_a_cfg," configure ",opcao_cfg," ",novo_valor,(char *)NULL);
	printf("\n\n%s\n\n",interp->result);
	return NULL;
/*
BUG : como ao criar internamente as entries etc sao precedidas de prefixo
	e sucedidas de um numero (contador) vai haver espiga da certa!
*/
}


/* ------------- Outras funcoes --------------------*/

SEXP ric(SEXP s)
{
	ric_show(cabeca);
	return NULL;
}

SEXP ric_state(SEXP s)	/* LAST TRY */
{
	SEXP res;
	char sym[20],*valor;

	SEXP aux,x,retorno=NULL;
	short first=1;

	forall(aux,x,s) 
		switch(x->n_type) {
			case SYM:
					if(first) {
						first--;
						if(!igual(x->n_symname,"NULL")) {
							if(x->n_symvalue && x->n_symvalue->n_type == STR) {
								retorno = strsexp(x->n_symvalue->n_str);
							} else {
								fprintf(stderr,"Ric_state error 1: first sym has a symvalue error!\a\n");
							}
						} else ;	/* se for NULL nao faz nada! */
					} else {
						strcpy(sym,x->n_symname+1);
            			valor = (char *)malloc(sizeof(char)*strlen(x->n_symvalue->n_str));
            			strcpy(valor,x->n_symvalue->n_str);

						    res =
						    conssexp(
        						symsexp("def"),
        						conssexp(
            						symsexp(sym),
            						conssexp(
                						strsexp(valor),
                						NULL
                    						)
                						)
            						);
    						xleval(res);
					}	
				break;
			default:
				printf("Ric_state error 2: type %d found?!?\n\a",x->n_type);
		}

	return retorno;
}


userinit()
{
	xmtcltkinit();

/* funcoes basicas */
	xlsubr("rgve2",ric_get_value_entry2);
	xlsubr("le",le);
	xlsubr("escreve",escreve);
	xlsubr("activa",ric_activate);
	xlsubr("desactiva",ric_deactivate);
	xlsubr("destroi",ric_destroy);

/* funcoes complementares */
	xlsubr("rtl",ric_top_level);   
	xlsubr("rf",ric_frame);

	xlsubr("rmb",ric_make_button);			/* cria um botao  */
	xlsubr("rab",ric_attrib_bind);			/* associa um bind a um botao ou altera o bind associado */

	xlsubr("rlbx",ric_listbox);				/* cria uma listbox	*/
	xlsubr("rwlb",ric_escreve_listbox);		/* escreve numa listbox */

	xlsubr("ric_menu",ric_menu);					/* cria menu ??? */
	xlsubr("ric_submenu",ric_submenu);				/* cria submenu ??? */
	xlsubr("ric_opcao",ric_opcao);

/* funcoes de configuracao de widgets existentes */
	xlsubr("rcfgw",ric_config_widget);

/* outras */

	xlsubr("ric_state",ric_state);	/* eu depois explico. Este era o antigo ric_state! */
	xlsubr("ric",ric);

}

#endif



