/*	xmsession.h - xmetoo session client routines
 *	vff@di.uminho.pt
 *	03/11/95
 */

#ifndef	__xmsession_h
#define	__xmsession_h

#define	MAXSESSIONS	(64)
#define	MAXCHANNELS	(16)
#define	MAXCHANNAME	(8 + 1)

typedef struct {
	char		name[MAXCHANNAME];
	int		mxid;
	unsigned	refcount;
} channel_t;

typedef	struct {
	short		session;
	size_t		nchannels;
	channel_t	channels[MAXCHANNELS];
} session_t;

int	new_session(void);
int	join_channel(short session, char channel[MAXCHANNAME]);
int	leave_channel(short session, char channel[MAXCHANNAME]);
int	list_sessions(short sessions[MAXSESSIONS], int * nsessions);
int	list_channels(short session, channel_t channels[MAXCHANNELS], 
	int * nchannels);
int	remove_session(short session);
int	stop_daemon(void);
int	D_start_daemon(void);

#endif	/* __xmsession_h */
