/* ---------------------------------------------------------------------
 #####
#     #  ######  #    #  #####            ####
#        #        #  #   #    #          #    #
 #####   #####     ##    #    #          #
      #  #         ##    #####    ###    #
#     #  #        #  #   #        ###    #    #
 #####   ######  #    #  #        ###     ####
 Versao <sexp.c1.2(92/10/29)>
---------------------------------------------------------------------
atomo(s:apsexp) (s->valor).atom
cons     66 sexp.c   aplista cons(s,l)
deffun   100 sexp.c  apsexp deffun(nome,l,p)
 deffun(str,lista,sexp) =
     mklista(<mkatconst("def"),
	      mkatomo(str),
	      mkatconst("lambda"),
	      mklista(lista),
	      sexp>)
funbin   84 sexp.c   apsexp funbin(nome,p1,p2)
 funbin(str,sexp1,sexp2) = <mkatconst(str),sexp1,sexp2>
funnar   117 sexp.c  apsexp funnar(nome,p)
 funnar(str,lista) = mklista(cons(mkatconst(str),lista))
funtre   92 sexp.c   apsexp funtre(nome,p1,p2,p3)
 funtre(str,sexp1,sexp2,sexp3) = <mkatconst(str),sexp1,sexp2,sexp3>
fununa   76 sexp.c   apsexp fununa(nome,p1)
 fununa(str,sexp) = <mkatconst(str),sexp>
head(l :aplista) (l->elemento)
isatomo(s :apsexp) (tipo(s) == ATOMO)
lista(s :apsexp) ((s->valor).lis)
lista2(a1,a2) cons(a1,cons(a2,nill))
lista3(a1,a2,a3) cons(a1,lista2(a2,a3))
lista4(a1,a2,a3,a4) cons(a1,lista3(a2,a3,a4))
mkatomo  48 sexp.c   apsexp mkatomo(s)
mkatconst  48 sexp.c   apsexp mkatconst(s)
mklista  57 sexp.c   apsexp mklista(l)
mkpair   112 sexp.c  apsexp mkpair(s1,s2)
mkter   112 sexp.c  apsexp mkpair(s1,s2,s3)
 mkpair(sexp1,sexp2) = mklista(cons(sexp1,cons(sexp2,<>)))
tail(l :aplista) (l->seg)
tipo(s :apsexp) (s->tag)
travessia        129 sexp.c           void travessia(s)
vazio(l :aplista) (l == nill)
conc: aplista * aplista -> aplista
conc(l1,l2) = l1^l2

--------------------------------------------------------------------- */
#include <stdio.h>

#include "sexp.h"

#define vazio(l) (l == nill) /*:aplista*/
#define jjreservasexp(x) if(!(x= ((apsexp)malloc(sizeof(celsexp)))))\
              jjabort("Falta de memoria(?)")
#define jjreservalista(x) if(!(x= ((aplista)malloc(sizeof(cellista)))))\
              jjabort("Falta de memoria(?)")

void jjabort(s)
char *s;
{fprintf(stderr,"ABORT: %s\n",s);
 exit(1);
}

char *malloc();
void funcao(),fechaf(),simb();

apsexp mkatomo(s)
char *s;
{ apsexp aux;
  jjreservasexp(aux);
  tipo(aux) = ATOMO;
  atomo(aux) = s;
  return(aux);
}

apsexp mkatconst(s)
char *s;
{ apsexp aux;
  jjreservasexp(aux);
  tipo(aux) = ATCONST;
  atomo(aux) = s;
  return(aux);
}

apsexp mklista(l)
aplista l;
{ apsexp aux;
  jjreservasexp(aux);
  tipo(aux) = LISTA;
  lista(aux) = l;
  return(aux);
}

aplista cons(s,l)
aplista l;
apsexp s;
{ aplista aux;
  jjreservalista(aux);
  head(aux) = s;
  tail(aux) = l;
  return(aux);
}

apsexp fununa(nome,p1)
char *nome;
apsexp p1;
{ return
   ( mklista(lista2(mkatconst(nome), p1)));
}
          
apsexp funbin(nome,p1,p2)
char *nome;
apsexp p1,p2;
{ return
   ( mklista (lista3 ( mkatconst(nome), p1, p2))); }
          
apsexp funtre(nome,p1,p2,p3)
char *nome;
apsexp p1,p2,p3;
{ return
   ( mklista ( lista4 ( mkatconst(nome), p1,p2,p3 ))); }

apsexp deffun(nome,l,p)
char *nome;
aplista l;
apsexp p;
{ return
   ( mklista
      ( cons (mkatconst("def"),
         lista4 ( mkatomo(nome), mkatconst("lambda"), mklista(l), p))));
}

apsexp mkpair(s1,s2)
apsexp s1,s2;
{ return ( mklista ( lista2 (s1,s2)));
}

apsexp mkter(s1,s2,s3)
apsexp s1,s2,s3;
{ return ( mklista ( lista3 (s1,s2,s3)));
}

apsexp funnar(nome,p)
char *nome;
aplista p;
{ return
   ( mklista
      ( cons (mkatconst(nome),
              p))); }

void travessia(s)
apsexp s;
{ aplista l,laux;
  if (isatomo(s))
    {simb(atomo(s));
     free(atomo(s));}
  else if (isatconst(s))
    simb(atomo(s));
  else
    { funcao("\0");
      l=lista(s);
      while(!(vazio(l)))
        { travessia(head(l));
          laux = l;
          l = tail(l);
          free(laux); }
      fechaf(); }
  free(s);
}

aplista conc(l1, l2)
aplista l1, l2;
{ aplista aux = l1;
 if (!vazio(l1))
   { if (!vazio(l2))
      { while (!vazio(tail(l1)))
         l1 = tail(l1);
        tail(l1) = l2; } }
 else /* l1 'e vazio */
   aux = l2;
 return(aux); }

apsexp copia(apsexp s);

aplista copial(l)
aplista l;
{ if (vazio(l)) { return nill;}
  else { return cons(copia(head(l)),copial(tail(l)));}
}

apsexp copia(apsexp s)
{ if      (isatomo(s))   {return mkatomo(strdup(atomo(s)));}
  else if (isatconst(s)) {return mkatconst(atomo(s));}
  else                   {return mklista(copial(lista(s)));}
}

aplista inverte(aplista l)
{ 
  aplista l2,l1 = nill;
  while (!vazio(l))
   { l2 = tail (l);
     tail(l) = l1;
     l1 = l ;
     l  = l2;
   }
 return l1;
}
