/*

	MEGABUG ha que testar os argumentos passados, para isso pode-se usar as
funcoes que ja estao def. Falar com prof. acerca disso!

*/


#ifdef TCLTK

#include<tcl.h>
#include<tk.h>
#include<stdlib.h>
#include<stdio.h>
#include<string.h>
#include<unistd.h>
#include<sys/types.h>
#include<signal.h>
#include"xmc.h"


#define igual(source,target) (strcmp(source,target)==0)
#define TK 1000    /* representa a janela principal */
#define ENTRY 1001
#define TOPLEVEL 1002
#define FRAME 1003
#define TK_LABEL 1004 
#define BUTTON 1005
#define LISTBOX 1006

#define MENU 1007
#define SUBMENU 1008	/* opcao dum menu ou submenu que nao seja final */
						/* i.e. aninda evoca outras abaixo de si	*/
#define OPCAO 1009		/* opcao final de um submenu ou menu */

#define ALL 1010 /* nao esta a ser usada */

#ifndef TRUE 
#define TRUE 1
#endif
#ifndef FALSE  
#define FALSE 0
#endif

	/* forward declarations */

void ric_inic( );
void do_it( );
void ric_clean_widgets( );
int I_ric_clean_widgets( );
int I_select_clean( );
void ric_show( );


	/* extern declarations */
extern struct node *xlenv ;
extern struct node *oblist ;
extern struct node *gettipo( );

/* --------------- minhas declaracoes ---------------- */

struct ric_tk {
	struct janela *jan_int;         /* lista de janelas internas a esta */
} ;

struct ric_menu {
	char titulo[50];
	char tamanho_x[5],tamanho_y[5];
	struct janela *jan_int;			/* lista de janelas internas a esta */
} ;

struct ric_submenu {
	char nome_visivel[20];
	char *funcao; /* isto ainda nao esta muito bem trabalhado... */
	struct janela *jan_int;
} ;

struct ric_opcao {
	char nome_visivel[20];
	SEXP to_execute;
} ;

struct ric_toplevel {
	char titulo[50];
	char tamanho_x[5],tamanho_y[5];
	struct janela *jan_int;         /* lista de janelas internas a esta */
} ;

struct ric_frame {
	struct janela *jan_int;         /* lista de janelas internas a esta */
} ;

struct ric_label {
	char texto_label[50];
} ;
struct ric_button {
	char nome_botao[50];	/* nome visivel do botao e nao o nome do objecto */
	char tamanho[10];		/* e' um char pois e' para facilitar o uso no Tk */
	SEXP evento; 
} ;

struct ric_listbox {
	char titulo[50];
	char tamanho_x[10];	/* largura - este devera ser inferido */
	char tamanho_y[10];	/* numero de linhas - o utilizador podera de forma
						   facultativa fornecer-lo */
} ;

struct ric_entry {
	char var_tcl[50],var_enter[50];
	char tam_entry[10];	/* relembre-se que esta valor e util para o Tk, donde interessa que seja char */
	int tipo_ret;
} ;

typedef struct janela {
	int tipo_janela;
	char nome_janela[50];
	
	union interna {
		struct ric_tk tk;
		struct ric_menu men;
		struct ric_submenu submen;
		struct ric_opcao opcao;
		struct ric_toplevel top;
		struct ric_label lab;
		struct ric_entry ent;
		struct ric_button but;
		struct ric_frame fra;
		struct ric_listbox box;
	} in;
	struct janela *irmas;			/* lista das janelas irmas */ 
} rv;

/* lista de Sexp associados a um botao (podera ser generalizado a outras widgets!) */


/* ------------------ var. globais -------------------- */

Tcl_Interp *interp;		/* variavel Tcl */
int contador;         	/* contador de widgets */

rv *cabeca;
char *funcao_bind=NULL;		/* isto e para apagar... cuidado com 'cla.c' onde isto e' usado! */

/* -------------- minhas funcoes ------------------------ */


/* Tk internals */

int I_opcao(ClientData clientdata, Tcl_Interp *interp, int argc, char *argv[]);

int I_exe_but(ClientData clientdata, Tcl_Interp *interp, int argc, char *argv[]);

/* others */

void ric_inic();

void do_it();

int ric_getptr(char janela[],rv **aux_x,rv **ant_x);

void ric_garbage(rv *aux);

void ric_clean_widgets(char janela[]);

void ric_append_widget(char nw[],char vc[],char vtcl[],char ve[],char tr[],char tamanho[],int insert_type,SEXP sexp);

void ric_append_widget_aux(char nw[],char vc[],char vtcl[],char ve[],char tr[],char tamanho[],int insert_type,SEXP sexp);

void ric_show(rv *aux);

char *nome_dum_simbolo(SEXP s);

char *ric_generic(SEXP s,int tipo);

void ric_activate2(rv *aux);

void ric_deactivate_aux(rv *aux);

rv *ric_getvarptr(rv *aux,char var_camila[]);

void ric_escreve_listbox_aux(SEXP s,rv *listbox);

void manda_tratar(Tcl_DString *str,SEXP s);

/* ---------------------------------------- */


SEXP ric_destroy(SEXP s);

SEXP ric_deactivate(SEXP s);

SEXP ric_activate(SEXP s);

SEXP ric_get_value_entry2(SEXP s);

SEXP le(SEXP s);

SEXP trata_sexp(SEXP x);

SEXP escreve(SEXP s);

SEXP ric_escreve_listbox(SEXP s);

SEXP ric_make_button(SEXP s);

SEXP ric_top_level(SEXP s);

SEXP ric_frame(SEXP s);

SEXP ric_listbox(SEXP s);

SEXP ric_menu(SEXP s);

SEXP ric_submenu(SEXP s);

SEXP ric_opcao(SEXP s);

SEXP ric_attrib_bind(SEXP s);

SEXP ric_config_widget(SEXP s);

SEXP ric(SEXP s);

SEXP ric_state(SEXP s);

#endif
