/* xmtdll.c - xmetoo-dll main module */

/* Win95 additions: fln (13.Feb.1997) */
#include <windows.h>
#include <stdlib.h>
#include <malloc.h>
#include "xmtdll.h"

char *xdlstr1(char *s,struct node *sexp)
{
    char *saux;
    struct node *nptr,*prval,*next;

    //if (!erro){
    if(sexp == NULL ) strcpy(s,"()");
    else {
        switch(sexp->n_type) {
            case SET :
            case REL :
            case FF :
            case FUN :
            case LIST :
                strcat(s,"(");
                for( nptr = sexp ; nptr != NULL ; nptr = next ) {
#ifdef USERTYPE
                    prval = nptr->n_listvalue ;
                    while( (prval != NULL) && (prval->n_type >= USERDEFTYPE) )
                        prval = prval->n_symvalue ;
                    strcpy(s,xdlstr1( s,prval )) ;
#else
                    xdlstr1( s,nptr->n_listvalue ) ;
#endif
                    if( (next = nptr->n_listnext) != NULL )
                        strcat(s," ") ;
                }
                strcat(s,")") ;
                break ;
            case SYM :
                strcat(s, sexp->n_symname ) ;
                strcat(s," ");
                break ;
            case INT :
                saux=(char *)calloc(1,sizeof(unsigned long));
                _itoa(sexp->n_int,saux,10);
                strcat(s,saux) ;
                strcat(s," ");
                free(saux);
                break ;
            default :
                strcat(s,"erro"); }
    }
    //}
    //else { strcpy(s,strerro);}
    //else { strcpy(s,"erro");}

	return (s);
}


DllExport int _stdcall xmInit(char *xmFile)
{
    char *fp[2];

// Verify if the file exists...
    fp[0] = _strdup(xmFile);
    fp[1] = '\0';
    
	return libxminit(1,fp) ? 1 : 0;
}


DllExport int _stdcall xmEval(char *xmIn,char *xmOut)
{
	struct node *sexp;

	xmOut[0] = '\0';
	sexp = libxmevalstr(xmIn);
	xmOut = xdlstr1(xmOut,sexp);

	return 1;
}
